local LFtimerActive = false;
local LFtimerStart = 0;
local LF_SWtimerActive = false;
local LF_SWtimerStart = 0;
local LF_loaded = false
local LF_addManagRegistered = false

--For converting a quality color to quality number.
local LF_QualityNum = {
		["WHITE"] 		= 1,
		["GREEN"] 		= 2,
		["BLUE"] 		= 3,
		["PURPLE"] 		= 4,
		["ORANGE"] 		= 5,
		["GOLD"] 		= 6
};

-- For Converting a quality number to a color code.
local LF_QualityCode = { "cffffffff", "cff00ff00", "cff0072bc", "cffc805f8", "cfff68e56", "cffa37d50" };

-- For converting a quality number to a quality name.
local LF_QualityName = { "WHITE", "GREEN", "BLUE", "PURPLE", "ORANGE", "GOLD" };

function Loot_OnLoad()
	if ( LF_loaded == true ) then
		return;
	end
	
	LF_playerName = UnitName("player");
	if ( LF_playerName == nil or LF_playerName == "" ) then
		return;
	end
	local lootFilterDefaultSettings = {
			["ENABLE"] 					= true,
			["showLoot"] 				= true,
			["showJunk"] 				= true,
			["useWildcards"] 			= true,
			["EnableSweepGarbage"]		= false,
			["sweepGarbageOnLoot"]		= false,
			["autoSweepGarbage"]		= false,
			["enableFilterOnPickup"]	= true,
			["showGarbageLog"]			= true,
			["chatToUse"]				= 1,
			["fastLooting"]				= true,
			["disKey"]					= 1,
			["EnableQualityFilter"]		= false,
			["QualityFilter"]			= LF_QualityNum["WHITE"]
	};
    if (type(lootFilterConf) ~= "table") then
		lootFilterConf = {}
		lootFilterConf[LF_playerName] = lootFilterDefaultSettings;
	else	
		if (type(lootFilterConf["ENABLE"]) ~= "nil") then
			--copy old settings
			ChatFrame1:AddMessage("palxer"..LF_playerName)
			local oldSettings = lootFilterConf
			lootFilterConf = {}
			lootFilterConf[LF_playerName] = oldSettings
			l_log("LootFilter - old settings found - moving them into new system");
		elseif type(lootFilterConf[LF_playerName]) ~= "table" then
			lootFilterConf[LF_playerName] = lootFilterDefaultSettings;
		end
		
		for k,v in pairs(lootFilterDefaultSettings) do
			if (lootFilterConf[LF_playerName][k] == nil) then
				lootFilterConf[LF_playerName][k] = v;
			end;
		end;
	end;
	
	--no blacklist at all
    if (type(lootFilterBlacklist) ~= "table") then
		lootFilterBlacklist = {};
	else
		--copy old settings
		for k,v in pairs(lootFilterBlacklist) do
			if (type(k) == 'number') then
				--there are old settings
				l_log("LootFilter - old blacklist found - moving it into new system");
				local oldSett = lootFilterBlacklist
				lootFilterBlacklist = {}
				lootFilterBlacklist[LF_playerName] = oldSett
				break
			end;
		end;	
	end
	-- no blacklist for current player
	if (type(lootFilterBlacklist[LF_playerName]) ~= "table") then
		lootFilterBlacklist[LF_playerName] = {};
	end;
	
	-- Load Picklist.
	--no Picklist at all
    if (type(lootFilterPicklist) ~= "table") then
		lootFilterPicklist = {};
	else
		--copy old settings
		for k,v in pairs(lootFilterPicklist) do
			if (type(k) == 'number') then
				--there are old settings
				l_log("LootFilter - old Picklist found - moving it into new system");
				local oldSett = lootFilterPicklist
				lootFilterPicklist = {}
				lootFilterPicklist[LF_playerName] = oldSett
				break
			end;
		end;	
	end
	-- no Picklist for current player
	if (type(lootFilterPicklist[LF_playerName]) ~= "table") then
		lootFilterPicklist[LF_playerName] = {};
	end;
	
	--registerAddonManager()
	--if not AddonManager then
		l_log("LootFilter++ v 0.70 loaded");	
	--end	
	
	LF_loaded = true 

end;

function registerAddonManager()
    if AddonManager then
        local addon = {
            name = "LootFilter++", 
            description = "Throws away items you don't need", 
            icon = "Interface/BagFrame/garbagecan-normal.tga", 
            category = "Inventory",
            configFrame = LootFilterConfFrame, 
            slashCommands = "/lf", 
            miniButton = LootFilterMiniButton,
            version = "v0.70",
            author = "Onotole & Catshoes",
        }
        if AddonManager.RegisterAddonTable then
            AddonManager.RegisterAddonTable(addon)
        else
            AddonManager.RegisterAddon(addon.name, addon.description, addon.icon, addon.category, 
                addon.configFrame, addon.slashCommands, addon.miniButton, addon.onClickScript)
        end
    end	
end

function LootFilterFrame_OnEvent(this, event, arg1, arg2)
	if ( event == "VARIABLES_LOADED" ) then
        -- If the user does a /script ReloadUI() only this event will be called.
		if ( LF_loaded ~= true ) then
			Loot_OnLoad();
		end
		return;
	end
	if ( event == "UNIT_PORTRAIT_UPDATE" and arg1 == "player" ) then
		if ( LF_loaded ~= true ) then
			Loot_OnLoad();
		end
		return;
	end
end




function  LF_delayedClose()
	LFtimerStart = GetTickCount();
	LFtimerActive = true;
end;

function  LF_delayedSweep()
	LF_SWtimerStart = GetTickCount();
	LF_SWtimerActive = true;
end;

function LF_Update()
	if (LFtimerActive == true) then
		local timerHit = GetTickCount()-LFtimerStart;
		if (timerHit > 200) then
			--l_log("timer hit: ");
			-- ok, the timer worked now execute the callback
			LFtimerActive = false;
			BootyFrame:Hide();
		end;	
	end	
	if (LF_SWtimerActive == true) then
		local timerHit = GetTickCount()-LF_SWtimerStart;
		if (timerHit > 700) then
			-- ok, the timer worked now execute the callback
			LF_SWtimerActive = false;
			sweepGarbage();
		end;	
	end
end;

function LootingAction()
	if lootFilterConf[LF_playerName]["disKey"] == 1 then 
		if IsShiftKeyDown() then return end;
	elseif lootFilterConf[LF_playerName]["disKey"] == 2 then
		if IsAltKeyDown() then return end;
	else
		if IsCtrlKeyDown() then return end;
	end;	
	if lootFilterConf[LF_playerName]["ENABLE"] == false then return end;
	--  filtering on pickup
	--if lootFilterConf[LF_playerName]["enableFilterOnPickup"] then
		lootFilter();
	--end	
	--  sweeping garbage	
	if lootFilterConf[LF_playerName]["sweepGarbageOnLoot"] then
		LF_delayedSweep();
		--sweepGarbage();
	end	
end;

function lootFilter()
    local index = BootyFrame.page * MAX_BOOTYFRAME_ITEMS;
	local junkInLoot = false;
    local maxNum = GetBootyNumItems();
    local texture, name, count, quality;
    for i = 1, MAX_BOOTYFRAME_ITEMS do
        if ( i + index <= maxNum ) then
            texture, name, count, quality = GetBootyItemInfo(i + index);
            if ( texture and name ) then
				blacklisted = false;
				if lootFilterConf[LF_playerName]["enableFilterOnPickup"] then
					-- Check an item against the Picklist.
					-- If an item is on the Picklist, it is to be looted regardless of all other settings.
					picklisted = false;
					for k,v in pairs(lootFilterPicklist[LF_playerName]) do 
						local itype, idata, iname = ParseHyperlink( v );
						if (iname) then
							-- parse a hyperlink	
							v = iname
						end	
						v = string.gsub(v,"-","%%-")
						if  (lootFilterConf[LF_playerName]["useWildcards"] and 
							type(string.find(name, "^"..string.gsub(v,"*",".*").."$")) ~= "nil") or 
							(lootFilterConf[LF_playerName]["useWildcards"] == false and v == name)	then
							picklisted = true;
							break;
						end;
					end;
				
					-- Check the Quality Filter.
					-- Only items with a higher quality than the Quality Filter setting will be looted.
					-- The Quality Filter will not override the Blacklist.
					filtered = true;
					if lootFilterConf[LF_playerName]["EnableQualityFilter"] == true then
						if (tonumber(quality) + 1) >= tonumber(lootFilterConf[LF_playerName]["QualityFilter"]) then
							-- This item should be looted.
							filtered = false;
						else
							-- The item is of lesser quality, and should only be looted if it is on the Picklist.
							if picklisted == false then
								-- The item is not on the Picklist, so it will not be looted.
								blacklisted  = true;
								junkInLoot = true;
								if  lootFilterConf[LF_playerName]["showJunk"] then  
									link = GetBootyItemLink(i + index);
									l_log("Item below Quality Filter not looted: "..link);
								end;
							end;
							picklisted  = true;		-- The item is on the Picklist and should be looted.
						end;
					end;
				
					-- Check an item against the Blacklist, and the Quality Filter.
					-- Only check these if the item is NOT on the picklist.
					if picklisted == false then
						-- Check the Blacklist.
						for k,v in pairs(lootFilterBlacklist[LF_playerName]) do 
							local itype, idata, iname = ParseHyperlink( v );
							if (iname) then
								-- parse a hyperlink	
								v = iname
							end
							v = string.gsub(v,"-","%%-")
							if  (lootFilterConf[LF_playerName]["useWildcards"] and type(string.find(name, "^"..string.gsub(v,"*",".*").."$")) ~= "nil")or (lootFilterConf[LF_playerName]["useWildcards"] == false and v == name)	then
								blacklisted = true;
								junkInLoot = true;
								if  lootFilterConf[LF_playerName]["showJunk"] then  
									link = GetBootyItemLink(i + index);
									l_log("Blacklisted item not picked up: "..link);
								end;
								BootyFrame.takeTime = nil;
								break;
							end;
						end;
						
						
					end;
				end
				
				if blacklisted ==  false then
					link = GetBootyItemLink(i + index);
					ClickBootyItem(i + index)
					if  lootFilterConf[LF_playerName]["showLoot"] then
						if count > 1 then
							l_log("Loot: "..count.." "..link); 
						else 	
							l_log("Loot: "..link); 
						end;	
					end;
				end;
                --index = i + index;
            else
                -- No texture and name, do something
            end
        else	
				--we have som juk in loot, so it wont close, lets do it ourself
				-- call a closeBooty function in 100ms
				LF_delayedClose();
        end
    end
end;




function l_log(text,color)
	-- For printing to the Chat Log.
	local baseMsg = "[Loot]>";
	if lootFilterConf[LF_playerName]["chatToUse"] == 1 then ChatFrame1:AddMessage(baseMsg .. text ) end
	if lootFilterConf[LF_playerName]["chatToUse"] == 2 then ChatFrame2:AddMessage(baseMsg .. text ) end
	if lootFilterConf[LF_playerName]["chatToUse"] == 3 then ChatFrame3:AddMessage(baseMsg .. text ) end
	if lootFilterConf[LF_playerName]["chatToUse"] == 4 then ChatFrame4:AddMessage(baseMsg .. text ) end
end;


function LootFilterConfig(ebox, variable)
	EColor = "|cff00ffff ";	-- The color of error messages.
	if (type(variable) == "nil" or variable == "") then
		LootFilterConfFrame:Show();
		--Loot_usage();
	else
		local arg = string.upper(variable);
		if arg == "ON" then
			-- Turn on Lootfilter.
			lootFilterConf[LF_playerName]['ENABLE'] = true;
			l_log("LootFilter|cff00ff00 On|r");
		elseif 	arg == "OFF" then
			-- Turn off lootfilter.
			lootFilterConf[LF_playerName]['ENABLE'] = false;
			l_log("LootFilter|cffff0000 Off|r");
		elseif	arg == "STATUS" then
			-- Display the current status of Lootfilter.
			-- First copy the Quality Filter.
			l_num = lootFilterConf[LF_playerName]["QualityFilter"];
			if l_num == nil then l_num = 1; end
			-- Display on/off status.
			if lootFilterConf[LF_playerName]['ENABLE'] == true then
				-- Lootfilter is on.
				l_log("LootFilter|cff00ff00 On|r");
			else
				-- Lootfilter is off.
				l_log("LootFilter|cffff0000 Off|r");
			end
			-- Display Quality Filter status.
			if lootFilterConf[LF_playerName]["EnableQualityFilter"] == true then
				-- Quality Filter is enabled.
				l_log("Quality Filter set to|" .. LF_QualityCode[l_num] .. " ".. LF_QualityName[l_num] .. "|r.");
				l_log("Items of|" .. LF_QualityCode[l_num] .. " " .. LF_QualityName[l_num] .. "|r quality or better will be looted.");
			else
				-- Qulaity Filter is off.
				l_log("Quality Filter is|cffff0000 Off|r");
			end
		elseif string.find (arg, "SETQ") then
			-- For setting the lower limit of the Quality Filter
			local l_start, l_end, l_value = string.find(variable, "setq (.+)")
			local l_value = string.upper(trim(l_value));
			if LF_QualityNum[l_value] ~= nil then
				-- Change the Quality Fitler's lower limit.
				lootFilterConf[LF_playerName]["QualityFilter"] = LF_QualityNum[l_value];
				l_num = lootFilterConf[LF_playerName]["QualityFilter"];
				if l_num == nil then l_num = 1; end
				l_log("Quality Filter set to|" .. LF_QualityCode[l_num] .. " ".. l_value .. "|r.");
				l_log("Items of|" .. LF_QualityCode[l_num] .. " " .. l_value .. "|r quality or better will be looted.");
			else 	
				-- Something was typed wrong.
				l_log(EColor .. "Use /lootfilter setq quality_level to set the Quality Filter, i.e. /lootfilter setq Blue|r");
				l_log(EColor .. "Use the following parameters: White, Green, Blue, Purple, Orange, Gold.|r");
			end;
		elseif string.find (arg, "QFILTER") then
			-- For turning the Quality Filter on/off.
			local l_quality;
			local l_start, l_end, l_state = string.find(variable, "qfilter (.+)")
			local l_state = string.upper(trim(l_state));
			l_num = lootFilterConf[LF_playerName]["QualityFilter"];
			if l_num == nil then l_num = 1; end
			if l_state == "ON" then
				-- Turns on the Quality Filter.
				lootFilterConf[LF_playerName]["EnableQualityFilter"] = true;
				l_quality = LF_QualityName[l_num];
				l_log("Quality Filter|cff00ff00 On|r.");
				l_log("Items of|" .. LF_QualityCode[l_num] .. " " .. LF_QualityName[l_num] .. "|r quality or better will be looted.");
			elseif l_state == "OFF" then
				-- Turns off the Quality Filter
				lootFilterConf[LF_playerName]["EnableQualityFilter"] = false;
				l_log("Quality Filter|cffff0000 Off|r.");
			else
				-- Something was typed wrong.
				l_log(EColor .. "Use /lootfilter qfilter on to turn on the Quality Filter.|r");
				l_log(EColor .. "Use /lootfilter qfilter off to turn off the Quality Filter.|r");
			end;
		elseif 	arg == "SHOW" then
			-- List the items in the Picklist.
			l_log("Picklist items:");
			l_log("---------------------------");
			for k,v in pairs(lootFilterPicklist[LF_playerName]) do 
				l_log(v);
			end;	
			l_log("---------------------------");
		elseif 	arg == "LIST" then
			l_log("Blacklisted items:");
			l_log("---------------------------");
			for k,v in pairs(lootFilterBlacklist[LF_playerName]) do 
				l_log(v);
			end;	
			l_log("---------------------------");
		elseif string.find (arg, "PICK") then
			-- Add an item to the Picklist.
			if type(string.find(variable, "pick (.+)")) ~= "nil" then
				local l_start, l_end, l_item = string.find(variable, "pick (.+)")
				local l_item = trim(l_item);
				if l_item ~= "" then
					table.insert(lootFilterPicklist[LF_playerName], l_item);
					l_log(l_item .. " added into Picklist");
				else 	
					l_log(EColor .. "Use /lootfilter pick item_name to add an item into Picklist, i.e. /lootfilter pick Damaged Tool|r");
				end;	
			else 
				l_log(EColor .. "Use /lootfilter pick item_name to add an item into Picklist, i.e. /lootfilter pick Damaged Tool|r");
			end;
		elseif string.find (arg, "ADD") then
			if type(string.find(variable, "add (.+)")) ~= "nil" then
				local l_start, l_end, l_item = string.find(variable, "add (.+)")
				local l_item = trim(l_item);
				if l_item ~= "" then
					table.insert(lootFilterBlacklist[LF_playerName], l_item);
					l_log(l_item .. " added into Blacklist");
				else 	
					l_log(EColor .. "Use /lootfilter add item_name to add an item into blacklist, i.e. /lootfilter add Damaged Tool|r");
				end;	
			else 
				l_log(EColor .. "Use /lootfilter add item_name to add an item into blacklist, i.e. /lootfilter add Damaged Tool|r");
			end;
		elseif string.find (arg, "DELETE") then
			local removeFlag = false;
			if type(string.find(variable, "delete (.*)")) ~= "nil" then
				l_start, l_end, l_item = string.find(variable, "delete (.*)")	-- Get the item that the user wants to remove.
				local ltype, ldata, lname = ParseHyperlink( l_item );			-- Parse the item as a hyperlink
				for k,v in pairs(lootFilterPicklist[LF_playerName]) do 
						local itype, idata, iname = ParseHyperlink( v );
						if (iname) then
							-- parse a hyperlink	
							v = iname
						end					
					if (lname and v == lname) or v == l_item then
						table.remove(lootFilterPicklist[LF_playerName],k);
						removeFlag = true;
						break;
					end;	
				end;		
				if removeFlag then
					l_log(l_item .. " removed from Picklist");
				else 
					l_log(l_item .. " was not found");
				end;	
			else 
				l_log(EColor .. "Use /lootfilter delete item_name to remove an item from Picklist, i.e. /lootfilter delete Damaged Tool|r");
			end;
		elseif string.find (arg, "REMOVE") then
			local removeFlag = false;
			if type(string.find(variable, "remove (.*)")) ~= "nil" then
				l_start, l_end, l_item = string.find(variable, "remove (.*)")	-- Get the item that the user wants to remove.
				local ltype, ldata, lname = ParseHyperlink( l_item );			-- Parse the item as a hyperlink
				for k,v in pairs(lootFilterBlacklist[LF_playerName]) do 
						local itype, idata, iname = ParseHyperlink( v );
						if (iname) then
							-- parse a hyperlink	
							v = iname
						end			
					if (lname and v == lname) or v == l_item then
						table.remove(lootFilterBlacklist[LF_playerName],k);
						removeFlag = true;
						break;
					end;	
				end;		
				if removeFlag then
					l_log(l_item .. " removed from Blacklist");
				else 
					l_log(l_item .. " was not found");
				end;	
			else 
				l_log(EColor .. "Use /lootfilter remove item_name to remove an item from blacklist, i.e. /lootfilter remove Damaged Tool|r");
			end;			
		elseif arg == "HELP" or arg == "?" then
			-- The user wants to see the command line options.
			l_log("Use /lootfilter on/off to turn lootfilter on/off");
			l_log("Use /lootfilter add item_name to add an item into Blacklist, i.e. /lootfilter add Damaged Tool");
			l_log("Use /lootfilter remove item_name to remove an item from Blacklist, i.e. /lootfilter remove Damaged Tool");
			l_log("Use /lootfilter list to view items in the Blacklist.");
			l_log("Use /lootfilter pick item_name to add an item into Picklist, i.e. /lootfilter pick Damaged Tool");
			l_log("Use /lootfilter delete item_name to remove an item from Picklist, i.e. /lootfilter delete Damaged Tool");
			l_log("Use /lootfilter show to view items in the Blacklist.");
			l_log("Use /lootfilter qfilter on/off to turn on/off the Quality Filter.");
			l_log("Use /lootfilter setq quality_level to set the Quality Filter, i.e. /lootfilter setq Blue");
			l_log("Use the following parameters: White, Green, Blue, Purple, Orange, Gold.");
		else 
			Loot_usage();
		end;
	end;
end;

function Loot_usage()
	l_log(EColor .. "Use /lootfilter help or /lootfilter ? to show usage.|r");	
end;

function sweepGarbage()
	-- I have chosen not to incorporate the Picklist or Quality Filter with Garbage Sweeping.
	-- Those two features only work with Filtering on Pickup enabled.
	-- I have not included the Picklist, because I do not use garbage sweeping and just don't care.
	-- The Quality Filter was not included because including it would take a fair amount of work.
	if lootFilterConf[LF_playerName]["ENABLE"] == false then return end;
	if lootFilterConf[LF_playerName]["EnableSweepGarbage"] == false then return end;

	-- global
	garbageQuant = 0;
	-- loop over all inventory items and add the blacklisted into garbage bin
    local bagItemCount, bagTotalSlots = GetBagCount();
    for i = 1,bagTotalSlots do
		local itemID, itemIconFile, itemName, itemCount = GetBagItemInfo(i)
		if ( itemIconFile and itemName ) then
			RemoveGarbageItem(itemID);
			blacklisted = false;
			for k,v in pairs(lootFilterBlacklist[LF_playerName]) do 
				local itype, idata, iname = ParseHyperlink( v );
				if (iname) then
					-- parse a hyperlink	
					v = iname
				end				
				v = string.gsub(v,"-","%%-")
					if  (lootFilterConf[LF_playerName]["useWildcards"]
						and type(string.find(itemName, "^"..string.gsub(v,"*",".*").."$")) ~= "nil") 
						or (lootFilterConf[LF_playerName]["useWildcards"] == false and v == itemName)	then
					-- The item is in the Blacklist.
					blacklisted = true;
					garbageQuant = garbageQuant + 1
					if  lootFilterConf[LF_playerName]["showGarbageLog"] == true then  
						local itemLink = GetBagItemLink(itemID);
						if itemLink ~= nil then
							l_log("Item moved to garbage: "..itemCount.." "..itemLink);
						end
					end;
					-- todo move to garbage
					InsertGarbageItem(itemID);
					break;
				end;
			end;
		else
                -- No texture and name, do something
		end	
	end;

	if garbageQuant > 0 then
		--some garbage found, lets handle this
		if lootFilterConf[LF_playerName]["autoSweepGarbage"] == false then
			GarbageFrame:Show();
		else
			if garbageQuant > 3 then
				--to much stuff to throw away - maybe an error??
				StaticPopupDialogs["DELETE_TOO_MUCH_GARBAGE"]["text"] = "You are going to delete "..garbageQuant.." items, are you sure?"
				StaticPopup_Show("DELETE_TOO_MUCH_GARBAGE");
			else	
				if  lootFilterConf[LF_playerName]["showGarbageLog"] then  
					l_log(garbageQuant .. " garbage items were thrown away");
				end	
				--todo clickongarbage
				DeleteGarbageItems();
			end
		end;	
	end;
end;

SLASH_lootfilter1 = "/lootfilter";
SLASH_lootfilter2 = "/lf";
SlashCmdList["lootfilter"] = LootFilterConfig;
SLASH_sweepGarbage1 = "/sweepGarbage";
SlashCmdList["sweepGarbage"] = sweepGarbage;


function trim (s)
      return (string.gsub(s, "^%s*(.-)%s*$", "%1"))
end


StaticPopupDialogs["DELETE_TOO_MUCH_GARBAGE"] = {
	text = "",
	button1 = TEXT("YES"),
	button2 = TEXT("NO"),
	OnAccept = function()
		DeleteGarbageItems();
		l_log(garbageQuant  .. " garbage items were thrown away");
	end,
	OnCancel = function()
		CloseGarbageItems();
		l_log("Garbage items were not thrown away");
	end,	
	timeout = 0,
	whileDead = 1,
	exclusive = 1,
	showAlert = 1,
	hideOnEscape = 1
};